package dev.peerat.backend.utils;

import java.util.Properties;

import jakarta.mail.Message;
import jakarta.mail.MessagingException;
import jakarta.mail.PasswordAuthentication;
import jakarta.mail.Session;
import jakarta.mail.Transport;
import jakarta.mail.internet.InternetAddress;
import jakarta.mail.internet.MimeMessage;


public class Mail {
	private Session session;
	private String fromAddress;
	
	public Mail(String initUsername, String initPassword, String initSmtpHost, String initSmtpPort, String initFromAddress) {
		Properties props = new Properties();
        props.put("mail.smtp.starttls.enable", "true");
        props.put("mail.smtp.auth", "true");
        props.put("mail.smtp.host", initSmtpHost);
        props.put("mail.smtp.port", initSmtpPort);

        session = Session.getInstance(props,
          new jakarta.mail.Authenticator() {
            protected PasswordAuthentication getPasswordAuthentication() {
                return new PasswordAuthentication(initUsername, initPassword);
            }
          });
		
		
		fromAddress = initFromAddress.isBlank() ? "cyberbottle@peerat.dev" : initFromAddress;
	}
	
    public void send(String toAddress, String subject, String text) {
        try {

            Message message = new MimeMessage(session);
            message.setFrom(new InternetAddress(fromAddress));
            message.setRecipients(Message.RecipientType.TO,
                InternetAddress.parse(toAddress));
            message.setSubject(subject);
            message.setText(text);

            Transport.send(message);
        } catch (MessagingException e) {
            throw new RuntimeException(e);
        }
    }
}
